/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.dsl.binding

import metridoc.dsl.Services

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 5/24/11
 * Time: 3:07 PM
 */
class IllegalBindingException extends RuntimeException{

    def String property
    def Class expectedType
    def Class actualType
    def binding

    def static IllegalBindingException wrongServicesType(binding) {
        return new IllegalBindingException(actualType: binding.services.class, binding: binding,
                expectedType: Services.class, property: "services")
    }

    def static IllegalBindingException wrongNoOverrideType(binding) {
        return new IllegalBindingException(actualType: binding.noOverride.class, binding: binding,
                expectedType: Services.class, property: "noOverride")
    }

    def static IllegalBindingException wrongOverrideWithSameTypeType(binding) {
        return new IllegalBindingException(actualType: binding.overrideWithSameType.class, binding: binding,
                expectedType: Services.class, property: "overrideWithTheSameType")
    }

    @Override
    String getMessage() {
        return "the binding ${binding} has the wrong type for the property ${property} which has type ${actualType}, " +
                "the type must be ${expectedType}"
    }


}
