/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.project

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/11/11
 * Time: 11:50 AM
 * To change this template use File | Settings | File Templates.
 */
class ColumnDefinition implements Comparable<ColumnDefinition>{
    def String name
    def String type
    def Closure schema

    def Closure getSchema(delegate) {

        if(this.schema == null) {
            schema = {
                column(name:name, type:type)
            }
        }

        schema.delegate = delegate

        return schema
    }


    boolean equals(o) {
        if (this.is(o)) return true;
        if (getClass() != o.class) return false;

        ColumnDefinition that = (ColumnDefinition) o;

        if (name != that.name) return false;

        return true;
    }

    int hashCode() {
        return (name != null ? name.hashCode() : 0);
    }

    int compareTo(ColumnDefinition t) {
        return name.compareTo(t.name)
    }
}
