/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.project

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/11/11
 * Time: 4:25 PM
 * To change this template use File | Settings | File Templates.
 */
class IdSchemaGenerator {
    def Closure idSchema
    def Closure idLinkSchema

    def Closure getIdSchema() {

        if (idSchema == null) {
            idSchema = {name ->
                column(name: name, autoIncrement: true, type: "BIGINT UNSIGNED") {
                    constraints(nullable: false, primaryKey: true)
                }
            }
        }

        return idSchema
    }

    def Closure getLinkSchema() {

        if (idLinkSchema == null) {

            idLinkSchema = {name ->
                column(name: name)
            }
        }

        return idLinkSchema
    }

    def callIdSchema(String name, delegate) {
        def formattedName = formatName(name)
        def idSchema = getIdSchema()
        idSchema.delegate = delegate
        idSchema.call(formattedName)
    }

    def callLinkedSchema(String name, delegate) {
        def formattedName = formatName(name)
        def linkedColumnSchema = getLinkSchema()
        linkedColumnSchema.delegate = delegate
        linkedColumnSchema.call(formattedName)
    }


    def String formatName(String name) {
        if (!name.endsWith("_id")) {
            name += "_id"
        }

        return name
    }


}
